/*
	(c) Thomas Kamps, 2006
	This Code ist distributet under the GnuGLP v2
*/
#include <math.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

#include <errno.h>

int msgChars[8];
int orgChars[8];
	
int txtChar;
int bitTxtChar[8];

int fileLength;

FILE *forg;
FILE *fmsg;
FILE *fw;
	
int potenz(int base, int exp) {
	int pot = 1;
	for (int i = 0; i < exp; i++) {
		pot = pot * base;
	}
	return pot;
}
void readAndCompareChars() {
	for (int i = 0; i < 8; i++) {
		orgChars[i] = fgetc(forg);
		msgChars[i] = fgetc(fmsg);
		bitTxtChar[i] = abs(orgChars[i]-msgChars[i]);
	}
}

void buildByte() {
	txtChar = bitTxtChar[0] * 128;
	txtChar += bitTxtChar[1] *  64;
	txtChar += bitTxtChar[2] *  32;
	txtChar += bitTxtChar[3] *  16;
	txtChar += bitTxtChar[4] *   8;
	txtChar += bitTxtChar[5] *   4;
	txtChar += bitTxtChar[6] *   2;
	txtChar += bitTxtChar[7] *   1;
}
int main( int argc, char **args ) {

	int picLength;

	if (argc != 4 ) {
		printf("USUAGE: picencoder originalBMP BMPwithData fileToSaveData\n");
		return 0;
	}

	forg  = fopen(args[1], "r");
	if (!forg) {
		printf("File: %s does not exist!\n", args[1]);
		return 0;
	}
	
	fmsg = fopen(args[2], "r");
	if (!fmsg) {
		printf("File: %s does not exist!\n", args[2]);
		return 0;
	}
	
	fw   = fopen(args[3], "r");
	if (fw) {
		printf("File: %s does alerady exist! please specyfy a file that does not exist.\n", args[3]);
		fclose(fw);	
		return 0;
	}
	fw   = fopen(args[3], "w");


	if (forg && fmsg && fw) {

		//Header überspringen
		for (int i = 0; i < 54; i++) {
			orgChars[0] = fgetc(forg);
			msgChars[0] = fgetc(fmsg);
		}
		//Laenge der enthaltende Dati bestimmen
			fileLength = 0;
		for (int i = 0; i < 4; i++) {
			readAndCompareChars();
			buildByte();
			fileLength += txtChar*potenz(2,8*(3-i));
		}
		// Dekodieren
		for (int i = 0; i < fileLength; i++) {
			//Original und Botschaft auslesen und vergleichen 
			readAndCompareChars();
			//Neues Byte bauen
			buildByte();	
			//schreiben
			fputc(txtChar, fw);
		}
	}
	fclose(forg);
	fclose(fmsg);
	fclose(fw);
	
}
